// LayerHandles.jsx
// ©March 2008  Lloyd Alvarez  http://aescripts.com
//
//   Adds handles to selected Layers
//


var InPointFramesToExtend = 15;
var OutPointFramesToExtend = 15;



var proj = app.project;
	var undoStr = "Add Layer Handles";

	if (proj){
		var myComp = app.project.activeItem;
		if (myComp != null && (myComp instanceof CompItem)){
			app.beginUndoGroup(undoStr);
			
			var myLayers = myComp.selectedLayers;
			var saveIn = 0;
			var saveOut = 0;
			for (i=0; i <= myLayers.length-1; i++){
				saveIn = myLayers[i].inPoint;
				saveOut = myLayers[i].outPoint;
			
				if (myLayers[i].stretch > 0) {
	
				myLayers[i].inPoint = saveIn - currentFormatToTime(InPointFramesToExtend, myComp.frameRate) ;
				myLayers[i].outPoint = saveOut + currentFormatToTime(OutPointFramesToExtend, myComp.frameRate) ;
				} else {
				
				myLayers[i].inPoint = saveIn + currentFormatToTime(OutPointFramesToExtend, myComp.frameRate) ;
				myLayers[i].outPoint = saveOut - currentFormatToTime(InPointFramesToExtend, myComp.frameRate) ;
				}
				}
			
			app.endUndoGroup();
		} else {
			alert("Please select an active comp to use this script");
		}
	}
	else
	{
		alert("Please open a project first to use this script.");
	}
